<?php
/*
Plugin Name: Drop Down Categories
Plugin URI: http://www.typedby.com/archives/category/word-press/
Description: This plugin is to be used within an already existing drop down/jump menu code.  It will output a list of categories in the following format: "< option value="category permalink" >category name< /option >".  Tested with Word Press (ver. 1.5) and credit for the code goes to the <a href="http://www.wordpress.org">Word Press</a> team.
Version: 1.3
Author: Ria Baltazar
Author URI: http://www.typedby.com/
*/

// Edited wp_list_cats()

function dropdown_cats_exclude($args = '') {
	parse_str($args, $r);
	if (!isset($r['sort_column'])) $r['sort_column'] = 'name';
	if (!isset($r['sort_order'])) $r['sort_order'] = 'asc';
	if (!isset($r['optiondates'])) $r['optiondates'] = 0;
	if (!isset($r['optioncount'])) $r['optioncount'] = 0;
	if (!isset($r['hide_empty'])) $r['hide_empty'] = 1;
	if (!isset($r['children'])) $r['children'] = true;  
	if (!isset($r['child_of'])) $r['child_of'] = 0; 
	if (!isset($r['categories'])) $r['categories'] = 0;
	if (!isset($r['recurse'])) $r['recurse'] = 0; 
	if (!isset($r['exclude'])) $r['exclude'] = '';

	list_cats_dropdown_exclude($r['optionall'], $r['all'], $r['sort_column'], $r['sort_order'], $r['file'],	$r['list'], $r['optiondates'], $r['optioncount'], $r['hide_empty'], $r['use_desc_for_title'], $r['children'], $r['child_of'], $r['categories'], $r['recurse'], $r['feed'], $r['feed_image'], $r['exclude']);
}

// Edited list_cats()     

function list_cats_dropdown_exclude($optionall = 1, $all = 'All', $sort_column = 'name', $sort_order = 'asc', $file = '', $list = true, $optiondates = 0, $optioncount = 0, $hide_empty = 1, $use_desc_for_title = 1, $children=true, $child_of=0, $categories=0, $recurse=0, $feed = '', $feed_image = '', $exclude = '') {
	global $tablecategories, $tableposts, $tablepost2cat, $wpdb, $category_posts;
	global $querystring_start, $querystring_equal, $querystring_separator;
	// Optiondates now works
	if ('' == $file) {
		$file = get_settings('home') . '/' . get_settings('blogfilename');
	}

	$exclusions = '';
	if (!empty($exclude)) {
		$excats = preg_split('/[\s,]+/',$exclude);
		if (count($excats)) {
			foreach ($excats as $excat) {
				$exclusions .= ' AND cat_ID <> ' . intval($excat) . ' ';
			}
		}
	}

	if (intval($categories)==0){
		$sort_column = 'cat_'.$sort_column;

		$query  = "
			SELECT cat_ID, cat_name, category_nicename, category_description, category_parent
			FROM $tablecategories
			WHERE cat_ID > 0 $exclusions
			ORDER BY $sort_column $sort_order";

		$categories = $wpdb->get_results($query);
	} 
	if (!count($category_posts)) {
		$cat_counts = $wpdb->get_results("	SELECT cat_ID,
		COUNT($tablepost2cat.post_id) AS cat_count
		FROM $tablecategories 
		INNER JOIN $tablepost2cat ON (cat_ID = category_id)
		INNER JOIN $tableposts ON (ID = post_id)
		WHERE post_status = 'publish' $exclusions
		GROUP BY category_id");
		foreach ($cat_counts as $cat_count) {
			if (1 != intval($hide_empty) || $cat_count > 0) {
				$category_posts["$cat_count->cat_ID"] = $cat_count->cat_count;
			}
		}
	}
	
	if (intval($optiondates) == 1) {
		$cat_dates = $wpdb->get_results("	SELECT cat_ID,
		DAYOFMONTH(MAX(post_date)) AS lastday, MONTH(MAX(post_date)) AS lastmonth
		FROM $tablecategories 
		LEFT JOIN $tablepost2cat ON (cat_ID = category_id)
		LEFT JOIN $tableposts ON (ID = post_id)
		WHERE post_status = 'publish' $exclusions
		GROUP BY category_id");
		foreach ($cat_dates as $cat_date) {
			$category_lastday["$cat_date->cat_ID"] = $cat_date->lastday;
			$category_lastmonth["$cat_date->cat_ID"] = $cat_date->lastmonth;
		}
	}
	
	
	$num_found=0;
	$thelist = "";
	
	foreach ($categories as $category) {
		if ((intval($hide_empty) == 0 || isset($category_posts["$category->cat_ID"])) && (!$children || $category->category_parent == $child_of)) {
			$num_found++;

                    if ($category->category_parent == 0) {
			$link = '<option class="parent" value="'.get_category_link($category->cat_ID).'" ';
			$link .= '>';
			$link .= stripslashes($category->cat_name).'</option>';
                    } else {
			$link = '<option class="child" value="'.get_category_link($category->cat_ID).'" ';
			$link .= '>';
			$link .= '   - '.stripslashes($category->cat_name).'</option>';
                    }

		        if (intval($optioncount) == 1) {
                           if ($category->category_parent == 0) {
			      $link = '<option class="parent" value="'.get_category_link($category->cat_ID).'" ';
			      $link .= '>';
			      $link .= stripslashes($category->cat_name).' ('.intval($category_posts["$category->cat_ID"]).')</option>';
                           } else {
			      $link = '<option class="child" value="'.get_category_link($category->cat_ID).'" ';
			      $link .= '>';
			      $link .= '   - '.stripslashes($category->cat_name).' ('.intval($category_posts["$category->cat_ID"]).')</option>';
                           }
			}
			if (intval($optiondates) == 1) {
                           if ($category->category_parent == 0) {
			      $link = '<option class="parent" value="'.get_category_link($category->cat_ID).'" ';
			      $link .= '>';
			      $link .= stripslashes($category->cat_name).' - '.$category_lastmonth["$category->cat_ID"].'/'.$category_lastday["$category->cat_ID"];'</option>';
                           } else {
			      $link = '<option class="child" value="'.get_category_link($category->cat_ID).'" ';
			      $link .= '>';
			      $link .= '   - '.stripslashes($category->cat_name).' - '.$category_lastmonth["$category->cat_ID"].'/'.$category_lastday["$category->cat_ID"];'</option>';
                           }
                        }
                        if (intval($optioncount) == 1  && intval($optiondates) == 1) {
                           if ($category->category_parent == 0) {
			      $link = '<option class="parent" value="'.get_category_link($category->cat_ID).'" ';
			      $link .= '>';
			      $link .= stripslashes($category->cat_name).' ('.intval($category_posts["$category->cat_ID"]).')  - '.$category_lastmonth["$category->cat_ID"].'/'.$category_lastday["$category->cat_ID"];'</option>';
                           } else {
			      $link = '<option class="child" value="'.get_category_link($category->cat_ID).'" ';
			      $link .= '>';
			      $link .= '   - '.stripslashes($category->cat_name).' ('.intval($category_posts["$category->cat_ID"]).')  - '.$category_lastmonth["$category->cat_ID"].'/'.$category_lastday["$category->cat_ID"];'</option>';
                           }                                
			}
			if ($list) {
				$thelist .= $link;
			} else {
				$thelist .= $link;
			} 
			if ($children) $thelist .= list_cats_dropdown_exclude($optionall, $all, $sort_column, $sort_order, $file, $list, $optiondates, $optioncount, $hide_empty, $use_desc_for_title, $children, $category->cat_ID, $categories, 1, $feed, $feed_image, $exclude); 
		}
	}

	if ($recurse) {
		return $thelist;
	} 
	echo apply_filters('list_cats_dropdown_exclude', $thelist); 
}
?>